<?php
// editor.inc.php for diaRice - photo calendar 0.3 en/de 07.09.2007 13:46
// Copyright (c) 2007 Michael Daum,  visit http://webdaum.de/

class editor {

  var $elem = array();
  var $mode = "mixed";
  var $selection = array();
  
  function editor($mode="mixed") {
    
    $this->mode = $mode;
    
    $this->elem["html"] = array(
  	"p"=>P,
  	"b"=>B,
  	"strong"=>STRONG,
  	"h3"=>H3,
  	"em"=>EM,
  	"u"=>U,
  	"pre"=>PRE,
  	"div"=>DIV,
  	"code"=>CODE,
  	"small"=>SMALL,
  	"big"=>BIG,
  	"cite"=>CITE,
  	"blockquote"=>BLOCKQUOTE,
  	"br"=>BR,
  	"hr"=>HR,
  	"a"=>A,
  	"ul"=>UL,
  	"li"=>LI,
  	"table"=>TABLE,
  	"tr"=>TR,
  	"td"=>TD,
  	"url"=>URL,
  	"img"=>IMG,
  	"ent"=>ENT,
  	"unent"=>UNENT,
  	"ins"=>INS,
  	"del"=>DEL,
  	"!--"=>"HTML ".MENU_COMMENT
  	);
  	
  	// css is similiar to html:
  	$this->elem["css"] = $this->elem["html"];
  	unset ($this->elem["css"]["!--"]);
  	$this->elem["css"]["/**/"] ="SCRIPT ".MENU_COMMENT;
  	
  	// script:
  	$this->elem["script"] = array(
  	"script"=>"SCRIPT-Template",
  	"if"=>"if else",
  	"switch"=>"switch() {}",
  	"func"=>"function() {}",
  	"for"=>"for() {}",
  	"/**/"=>"SCRIPT ".MENU_COMMENT
  	);
  	
  	// php is different:
  	$this->elem["php"] = array(
  	"php"=>"PHP-Codeblock",
  	"echo"=>"ECHO text",
  	"print"=>"PRINT text"
  	) + $this->elem["script"];
  	
  	// js is different:
  	$this->elem["js"] = array(
  	"id"=>"getElementById",
  	"name"=>"getElementsByName",
  	) + $this->elem["script"];
  	
  	// mixed is a combination of html and php:
    $this->elem['mixed'] = $this->elem['html']+$this->elem['php'];
    $this->elem['templates'] = &$this->elem['mixed'];
    $this->elem['modules'] = &$this->elem['mixed'];
    $this->elem['extlink'] = &$this->elem['mixed'];
    
    
    $this->selection = $this->elem[$this->mode];
  	  	
  }
  
  function out($mode=0) {
  
    if($mode) {
    	$this->selection = $this->elem[$mode];
		}
    
    $out.="<div id=\"editor\">\n";
    
  	foreach($this->selection as $k => $v) {
  		$out.= "<input type=\"button\" class=\"$k\" value=\"$k\" title=\"$v\" onclick=\"edit(this,'$mode')\" />\n";
  	}
  	
  	$out.= "<br /></div>\n";
  	return $out;
  }
  
  function switch_mode() {
  
		// user select:
  	$out = "<fieldset>\n<legend>Mode</legend>\n";
  	$radios = array("html","php","mixed","css");
  	foreach ($radios as $radio) {
  		$checked = $_GET['mode']==$radio?' checked="checked"':"";
    	$out.="<dfn>".strtoupper($radio).": </dfn><input$checked type=\"radio\" name=\"editormode\" value=\"$radio\" /><br />\n";
    }
		$out.="</fieldset>\n";
  	return $out;
  }
}



?>