<?php
// file_mngr.inc.php for diaRice - photo calendar 0.3 en/de 07.09.2007 13:46
// Copyright (c) 2007-2008 Michael Daum,  visit http://webdaum.de/

// read and check dirs and files
class file_mngr {  
	function go ($quelle,$needle='',$mode='dir',$period=7) {

		$dirList[] = $quelle;
		$title = 'not found!';
		$basename = 'no file!';
		$output = array();
		$period = time() - 1000*60*60*24*$period;

		while ( ($currDir = array_pop($dirList)) !== NULL ) {
			$dir = opendir($currDir);
			while((false!==($file=readdir($dir)))) {
				$needle = ($needle=='') ? $file : $needle;
				if($file =='.' || $file == '..') {
				   continue;
				}
			   
				$fullName = $currDir . '/' . $file; // DIRECTORY_SEPARATOR
				if ( is_dir ( $fullName ) ) {
				   array_push ( $dirList, $fullName );
				   continue;
				}
				if(is_file($fullName)) {
					$path_parts = pathinfo($fullName);
					if(strpos('htm',$path_parts['extension'])!==false) {
						$title = $this->get_title(file_get_contents($fullName));
					}
					$basename = str_replace('.'.$path_parts['extension'], '', $file);
				}
				$tempDir = str_replace($quelle.'/', '', $currDir);
				if (preg_match("/$needle/",$file)) {
					if($mode=='dir') {
					$output["$currDir"]= "$tempDir";
					} else if($mode=='file') {
					$output["$currDir/$file"]= "$file";
					} else if($mode=='image') {
						if (@getimagesize("$currDir/$file")) {
							if(strtolower($path_parts['extension'])!='psd') {
								$output["$currDir/$file"]= "$file";
							}
						}
					} else if($mode=='process') {
						$this->processFile ($file, $tempDir, $basename, $title);
					} else if($mode =='filemtime') {
						if(filemtime($fullName)>$period) {
							$output["$currDir/$file"]= "$file";
						}
					}
				}
			}
			closedir($dir);
		}
		natcasesort($output);
		if ($mode!='process') return $output;
	}
	   
  function processFile ( $file, $dir, $basename, $title) {
    print ("\$d[\"$basename\"] = new ord_datei(\"$file\", \"$dir\", \"$basename\", \"$title\");\n");
  }
   
  function get_title($file) {
  
     @preg_match( '/<title>([a-z 0-9]*)<\/title>/si', $file, $match );
     
     $title = strip_tags(@$match[1]);
     return $title;
  }
	function check_dirs($list=array()) {
		if(!is_array($list)) {
			$list = array($list);
		}
		foreach ($list as $dir) {
			if(is_dir($dir)) {
				continue;
			} else {
				return false;
			}
		}
		return true;
	}
	function create_dirs($list=array()) {
		$msg = '';
		foreach ($list as $dir) {
			if(is_dir($dir)) {
				continue;
			} else {
				if(!mkdir($dir)) {
					$msg.= "Can not create directory $dir";
				} else {
					if(file_put_contents("$dir/test.txt",'test')) {
						if(!is_writable("$dir/test.txt")) {
							$msg.= "Can not write to testfile in new dir $dir!<br />\n";
						}
						unlink("$dir/test.txt");
					} else {
						$msg.= "Can not write to new dir $dir!<br />\n";
					}
				}
			}
		}
		return $msg;
	}
	function check_files($list=array()) {
		$out = true;
		foreach ($list as $file) {
			if(is_file($file)) {
				continue;
			} else {
				return false;
			}
		}
		return true;
	}

}

?>